Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/nil/eth/eth.c	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -42,5 +42,5 @@
 #include <byteorder.h>
 #include <str.h>
-#include <err.h>
+#include <errno.h>
 
 #include <ipc/ipc.h>
@@ -66,355 +66,369 @@
 #include "eth_header.h"
 
-/** The module name.
- */
+/** The module name. */
 #define NAME  "eth"
 
-/** Reserved packet prefix length.
- */
-#define ETH_PREFIX		(sizeof(eth_header_t) + sizeof(eth_header_lsap_t) + sizeof(eth_header_snap_t))
-
-/** Reserved packet suffix length.
- */
-#define ETH_SUFFIX		sizeof(eth_fcs_t)
-
-/** Maximum packet content length.
- */
+/** Reserved packet prefix length. */
+#define ETH_PREFIX \
+	(sizeof(eth_header_t) + sizeof(eth_header_lsap_t) + \
+	sizeof(eth_header_snap_t))
+
+/** Reserved packet suffix length. */
+#define ETH_SUFFIX \
+	sizeof(eth_fcs_t)
+
+/** Maximum packet content length. */
 #define ETH_MAX_CONTENT 1500u
 
-/** Minimum packet content length.
- */
+/** Minimum packet content length. */
 #define ETH_MIN_CONTENT 46u
 
-/** Maximum tagged packet content length.
- */
-#define ETH_MAX_TAGGED_CONTENT(flags)	(ETH_MAX_CONTENT - ((IS_8023_2_LSAP(flags) || IS_8023_2_SNAP(flags)) ? sizeof(eth_header_lsap_t) : 0) - (IS_8023_2_SNAP(flags) ? sizeof(eth_header_snap_t) : 0))
-
-/** Minimum tagged packet content length.
- */
-#define ETH_MIN_TAGGED_CONTENT(flags)	(ETH_MIN_CONTENT - ((IS_8023_2_LSAP(flags) || IS_8023_2_SNAP(flags)) ? sizeof(eth_header_lsap_t) : 0) - (IS_8023_2_SNAP(flags) ? sizeof(eth_header_snap_t) : 0))
-
-/** Dummy flag shift value.
- */
+/** Maximum tagged packet content length. */
+#define ETH_MAX_TAGGED_CONTENT(flags) \
+	(ETH_MAX_CONTENT - \
+	((IS_8023_2_LSAP(flags) || IS_8023_2_SNAP(flags)) ? \
+	sizeof(eth_header_lsap_t) : 0) - \
+	(IS_8023_2_SNAP(flags) ? sizeof(eth_header_snap_t) : 0))
+
+/** Minimum tagged packet content length. */
+#define ETH_MIN_TAGGED_CONTENT(flags) \
+	(ETH_MIN_CONTENT - \
+	((IS_8023_2_LSAP(flags) || IS_8023_2_SNAP(flags)) ? \
+	sizeof(eth_header_lsap_t) : 0) - \
+	(IS_8023_2_SNAP(flags) ? sizeof(eth_header_snap_t) : 0))
+
+/** Dummy flag shift value. */
 #define ETH_DUMMY_SHIFT	0
 
-/** Mode flag shift value.
- */
+/** Mode flag shift value. */
 #define ETH_MODE_SHIFT	1
 
 /** Dummy device flag.
- *  Preamble and FCS are mandatory part of the packets.
- */
-#define ETH_DUMMY				(1 << ETH_DUMMY_SHIFT)
+ * Preamble and FCS are mandatory part of the packets.
+ */
+#define ETH_DUMMY		(1 << ETH_DUMMY_SHIFT)
 
 /** Returns the dummy flag.
- *  @see ETH_DUMMY
- */
-#define IS_DUMMY(flags)		((flags) &ETH_DUMMY)
+ * @see ETH_DUMMY
+ */
+#define IS_DUMMY(flags)		((flags) & ETH_DUMMY)
 
 /** Device mode flags.
- *  @see ETH_DIX
- *  @see ETH_8023_2_LSAP
- *  @see ETH_8023_2_SNAP
- */
-#define ETH_MODE_MASK			(3 << ETH_MODE_SHIFT)
-
-/** DIX Ethernet mode flag.
- */
-#define ETH_DIX					(1 << ETH_MODE_SHIFT)
+ * @see ETH_DIX
+ * @see ETH_8023_2_LSAP
+ * @see ETH_8023_2_SNAP
+ */
+#define ETH_MODE_MASK		(3 << ETH_MODE_SHIFT)
+
+/** DIX Ethernet mode flag. */
+#define ETH_DIX			(1 << ETH_MODE_SHIFT)
 
 /** Returns whether the DIX Ethernet mode flag is set.
- *  @param[in] flags The ethernet flags.
- *  @see ETH_DIX
- */
-#define IS_DIX(flags)			(((flags) &ETH_MODE_MASK) == ETH_DIX)
-
-/** 802.3 + 802.2 + LSAP mode flag.
- */
-#define ETH_8023_2_LSAP			(2 << ETH_MODE_SHIFT)
+ *
+ * @param[in] flags	The ethernet flags.
+ * @see ETH_DIX
+ */
+#define IS_DIX(flags)		(((flags) & ETH_MODE_MASK) == ETH_DIX)
+
+/** 802.3 + 802.2 + LSAP mode flag. */
+#define ETH_8023_2_LSAP		(2 << ETH_MODE_SHIFT)
 
 /** Returns whether the 802.3 + 802.2 + LSAP mode flag is set.
- *  @param[in] flags The ethernet flags.
- *  @see ETH_8023_2_LSAP
- */
-#define IS_8023_2_LSAP(flags)	(((flags) &ETH_MODE_MASK) == ETH_8023_2_LSAP)
-
-/** 802.3 + 802.2 + LSAP + SNAP mode flag.
- */
-#define ETH_8023_2_SNAP			(3 << ETH_MODE_SHIFT)
+ *
+ * @param[in] flags	The ethernet flags.
+ * @see ETH_8023_2_LSAP
+ */
+#define IS_8023_2_LSAP(flags)	(((flags) & ETH_MODE_MASK) == ETH_8023_2_LSAP)
+
+/** 802.3 + 802.2 + LSAP + SNAP mode flag. */
+#define ETH_8023_2_SNAP		(3 << ETH_MODE_SHIFT)
 
 /** Returns whether the 802.3 + 802.2 + LSAP + SNAP mode flag is set.
- *  @param[in] flags The ethernet flags.
- *  @see ETH_8023_2_SNAP
- */
-#define IS_8023_2_SNAP(flags)	(((flags) &ETH_MODE_MASK) == ETH_8023_2_SNAP)
+ *
+ * @param[in] flags	The ethernet flags.
+ * @see ETH_8023_2_SNAP
+ */
+#define IS_8023_2_SNAP(flags)	(((flags) & ETH_MODE_MASK) == ETH_8023_2_SNAP)
 
 /** Type definition of the ethernet address type.
- *  @see eth_addr_type
- */
-typedef enum eth_addr_type	eth_addr_type_t;
+ * @see eth_addr_type
+ */
+typedef enum eth_addr_type eth_addr_type_t;
 
 /** Type definition of the ethernet address type pointer.
- *  @see eth_addr_type
- */
-typedef eth_addr_type_t *	eth_addr_type_ref;
-
-/** Ethernet address type.
- */
-enum eth_addr_type{
-	/** Local address.
-	 */
+ * @see eth_addr_type
+ */
+typedef eth_addr_type_t *eth_addr_type_ref;
+
+/** Ethernet address type. */
+enum eth_addr_type {
+	/** Local address. */
 	ETH_LOCAL_ADDR,
-	/** Broadcast address.
-	 */
+	/** Broadcast address. */
 	ETH_BROADCAST_ADDR
 };
 
-/** Ethernet module global data.
- */
-eth_globals_t	eth_globals;
-
-/** @name Message processing functions
- */
-/*@{*/
-
-/** Processes IPC messages from the registered device driver modules in an infinite loop.
- *  @param[in] iid The message identifier.
- *  @param[in,out] icall The message parameters.
- */
-void eth_receiver(ipc_callid_t iid, ipc_call_t * icall);
-
-/** Registers new device or updates the MTU of an existing one.
- *  Determines the device local hardware address.
- *  @param[in] device_id The new device identifier.
- *  @param[in] service The device driver service.
- *  @param[in] mtu The device maximum transmission unit.
- *  @returns EOK on success.
- *  @returns EEXIST if the device with the different service exists.
- *  @returns ENOMEM if there is not enough memory left.
- *  @returns Other error codes as defined for the net_get_device_conf_req() function.
- *  @returns Other error codes as defined for the netif_bind_service() function.
- *  @returns Other error codes as defined for the netif_get_addr_req() function.
- */
-int eth_device_message(device_id_t device_id, services_t service, size_t mtu);
-
-/** Registers receiving module service.
- *  Passes received packets for this service.
- *  @param[in] service The module service.
- *  @param[in] phone The service phone.
- *  @returns EOK on success.
- *  @returns ENOENT if the service is not known.
- *  @returns ENOMEM if there is not enough memory left.
- */
-int eth_register_message(services_t service, int phone);
-
-/** Returns the device packet dimensions for sending.
- *  @param[in] device_id The device identifier.
- *  @param[out] addr_len The minimum reserved address length.
- *  @param[out] prefix The minimum reserved prefix size.
- *  @param[out] content The maximum content size.
- *  @param[out] suffix The minimum reserved suffix size.
- *  @returns EOK on success.
- *  @returns EBADMEM if either one of the parameters is NULL.
- *  @returns ENOENT if there is no such device.
- */
-int eth_packet_space_message(device_id_t device_id, size_t * addr_len, size_t * prefix, size_t * content, size_t * suffix);
-
-/** Returns the device hardware address.
- *  @param[in] device_id The device identifier.
- *  @param[in] type Type of the desired address.
- *  @param[out] address The device hardware address.
- *  @returns EOK on success.
- *  @returns EBADMEM if the address parameter is NULL.
- *  @returns ENOENT if there no such device.
- */
-int eth_addr_message(device_id_t device_id, eth_addr_type_t type, measured_string_ref * address);
-
-/** Sends the packet queue.
- *  Sends only packet successfully processed by the eth_prepare_packet() function.
- *  @param[in] device_id The device identifier.
- *  @param[in] packet The packet queue.
- *  @param[in] sender The sending module service.
- *  @returns EOK on success.
- *  @returns ENOENT if there no such device.
- *  @returns EINVAL if the service parameter is not known.
- */
-int eth_send_message(device_id_t device_id, packet_t packet, services_t sender);
-
-/*@}*/
-
-/** Processes the received packet and chooses the target registered module.
- *  @param[in] flags The device flags.
- *  @param[in] packet The packet.
- *  @returns The target registered module.
- *  @returns NULL if the packet is not long enough.
- *  @returns NULL if the packet is too long.
- *  @returns NULL if the raw ethernet protocol is used.
- *  @returns NULL if the dummy device FCS checksum is invalid.
- *  @returns NULL if the packet address length is not big enough.
- */
-eth_proto_ref eth_process_packet(int flags, packet_t packet);
-
-/** Prepares the packet for sending.
- *  @param[in] flags The device flags.
- *  @param[in] packet The packet.
- *  @param[in] src_addr The source hardware address.
- *  @param[in] ethertype The ethernet protocol type.
- *  @param[in] mtu The device maximum transmission unit.
- *  @returns EOK on success.
- *  @returns EINVAL if the packet addresses length is not long enough.
- *  @returns EINVAL if the packet is bigger than the device MTU.
- *  @returns ENOMEM if there is not enough memory in the packet.
- */
-int eth_prepare_packet(int flags, packet_t packet, uint8_t * src_addr, int ethertype, size_t mtu);
-
-DEVICE_MAP_IMPLEMENT(eth_devices, eth_device_t)
-
-INT_MAP_IMPLEMENT(eth_protos, eth_proto_t)
-
-int nil_device_state_msg_local(int nil_phone, device_id_t device_id, int state){
+/** Ethernet module global data. */
+eth_globals_t eth_globals;
+
+DEVICE_MAP_IMPLEMENT(eth_devices, eth_device_t);
+INT_MAP_IMPLEMENT(eth_protos, eth_proto_t);
+
+int nil_device_state_msg_local(int nil_phone, device_id_t device_id, int state)
+{
 	int index;
 	eth_proto_ref proto;
 
 	fibril_rwlock_read_lock(&eth_globals.protos_lock);
-	for(index = eth_protos_count(&eth_globals.protos) - 1; index >= 0; -- index){
+	for (index = eth_protos_count(&eth_globals.protos) - 1; index >= 0;
+	    index--) {
 		proto = eth_protos_get_index(&eth_globals.protos, index);
-		if(proto && proto->phone){
-			il_device_state_msg(proto->phone, device_id, state, proto->service);
+		if (proto && proto->phone) {
+			il_device_state_msg(proto->phone, device_id, state,
+			    proto->service);
 		}
 	}
 	fibril_rwlock_read_unlock(&eth_globals.protos_lock);
+	
 	return EOK;
 }
 
-int nil_initialize(int net_phone){
-	ERROR_DECLARE;
+int nil_initialize(int net_phone)
+{
+	int rc;
 
 	fibril_rwlock_initialize(&eth_globals.devices_lock);
 	fibril_rwlock_initialize(&eth_globals.protos_lock);
+	
 	fibril_rwlock_write_lock(&eth_globals.devices_lock);
 	fibril_rwlock_write_lock(&eth_globals.protos_lock);
 	eth_globals.net_phone = net_phone;
-	eth_globals.broadcast_addr = measured_string_create_bulk("\xFF\xFF\xFF\xFF\xFF\xFF", CONVERT_SIZE(uint8_t, char, ETH_ADDR));
-	if(! eth_globals.broadcast_addr){
-		return ENOMEM;
-	}
-	ERROR_PROPAGATE(eth_devices_initialize(&eth_globals.devices));
-	if(ERROR_OCCURRED(eth_protos_initialize(&eth_globals.protos))){
+	eth_globals.broadcast_addr =
+	    measured_string_create_bulk("\xFF\xFF\xFF\xFF\xFF\xFF",
+	    CONVERT_SIZE(uint8_t, char, ETH_ADDR));
+	if (!eth_globals.broadcast_addr) {
+		rc = ENOMEM;
+		goto out;
+	}
+	rc = eth_devices_initialize(&eth_globals.devices);
+	if (rc != EOK) {
+		free(eth_globals.broadcast_addr);
+		goto out;
+	}
+	rc = eth_protos_initialize(&eth_globals.protos);
+	if (rc != EOK) {
+		free(eth_globals.broadcast_addr);
 		eth_devices_destroy(&eth_globals.devices);
-		return ERROR_CODE;
-	}
+	}
+out:
 	fibril_rwlock_write_unlock(&eth_globals.protos_lock);
 	fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-	return EOK;
-}
-
-int eth_device_message(device_id_t device_id, services_t service, size_t mtu){
-	ERROR_DECLARE;
-
+	
+	return rc;
+}
+
+/** Processes IPC messages from the registered device driver modules in an
+ * infinite loop.
+ *
+ * @param[in] iid	The message identifier.
+ * @param[in,out] icall	The message parameters.
+ */
+static void eth_receiver(ipc_callid_t iid, ipc_call_t *icall)
+{
+	packet_t packet;
+	int rc;
+
+	while (true) {
+		switch (IPC_GET_METHOD(*icall)) {
+		case NET_NIL_DEVICE_STATE:
+			nil_device_state_msg_local(0, IPC_GET_DEVICE(icall),
+			    IPC_GET_STATE(icall));
+			ipc_answer_0(iid, EOK);
+			break;
+		case NET_NIL_RECEIVED:
+			rc = packet_translate_remote(eth_globals.net_phone,
+			    &packet, IPC_GET_PACKET(icall));
+			if (rc == EOK) {
+				rc = nil_received_msg_local(0,
+				    IPC_GET_DEVICE(icall), packet, 0);
+			}
+			ipc_answer_0(iid, (ipcarg_t) rc);
+			break;
+		default:
+			ipc_answer_0(iid, (ipcarg_t) ENOTSUP);
+		}
+		
+		iid = async_get_call(icall);
+	}
+}
+
+/** Registers new device or updates the MTU of an existing one.
+ *
+ * Determines the device local hardware address.
+ *
+ * @param[in] device_id	The new device identifier.
+ * @param[in] service	The device driver service.
+ * @param[in] mtu	The device maximum transmission unit.
+ * @returns		EOK on success.
+ * @returns		EEXIST if the device with the different service exists.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
+ *			net_get_device_conf_req() function.
+ * @returns		Other error codes as defined for the
+ *			netif_bind_service() function.
+ * @returns		Other error codes as defined for the
+ *			netif_get_addr_req() function.
+ */
+static int
+eth_device_message(device_id_t device_id, services_t service, size_t mtu)
+{
 	eth_device_ref device;
 	int index;
-	measured_string_t names[2] = {{str_dup("ETH_MODE"), 8}, {str_dup("ETH_DUMMY"), 9}};
+	measured_string_t names[2] = {
+		{
+			(char *) "ETH_MODE",
+			8
+		},
+		{
+			(char *) "ETH_DUMMY",
+			9
+		}
+	};
 	measured_string_ref configuration;
 	size_t count = sizeof(names) / sizeof(measured_string_t);
-	char * data;
+	char *data;
 	eth_proto_ref proto;
+	int rc;
 
 	fibril_rwlock_write_lock(&eth_globals.devices_lock);
 	// an existing device?
 	device = eth_devices_find(&eth_globals.devices, device_id);
-	if(device){
-		if(device->service != service){
+	if (device) {
+		if (device->service != service) {
 			printf("Device %d already exists\n", device->device_id);
 			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
 			return EEXIST;
-		}else{
-			// update mtu
-			if((mtu > 0) && (mtu <= ETH_MAX_TAGGED_CONTENT(device->flags))){
-				device->mtu = mtu;
-			}else{
-				 device->mtu = ETH_MAX_TAGGED_CONTENT(device->flags);
+		}
+		
+		// update mtu
+		if ((mtu > 0) && (mtu <= ETH_MAX_TAGGED_CONTENT(device->flags)))
+			device->mtu = mtu;
+		else
+			device->mtu = ETH_MAX_TAGGED_CONTENT(device->flags);
+		
+		printf("Device %d already exists:\tMTU\t= %d\n",
+		    device->device_id, device->mtu);
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+		
+		// notify all upper layer modules
+		fibril_rwlock_read_lock(&eth_globals.protos_lock);
+		for (index = 0; index < eth_protos_count(&eth_globals.protos);
+		    index++) {
+			proto = eth_protos_get_index(&eth_globals.protos,
+			    index);
+			if (proto->phone) {
+				il_mtu_changed_msg(proto->phone,
+				    device->device_id, device->mtu,
+				    proto->service);
 			}
-			printf("Device %d already exists:\tMTU\t= %d\n", device->device_id, device->mtu);
-			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-			// notify all upper layer modules
-			fibril_rwlock_read_lock(&eth_globals.protos_lock);
-			for(index = 0; index < eth_protos_count(&eth_globals.protos); ++ index){
-				proto = eth_protos_get_index(&eth_globals.protos, index);
-				if (proto->phone){
-					il_mtu_changed_msg(proto->phone, device->device_id, device->mtu, proto->service);
-				}
-			}
-			fibril_rwlock_read_unlock(&eth_globals.protos_lock);
-			return EOK;
-		}
-	}else{
-		// create a new device
-		device = (eth_device_ref) malloc(sizeof(eth_device_t));
-		if(! device){
-			return ENOMEM;
-		}
-		device->device_id = device_id;
-		device->service = service;
-		device->flags = 0;
-		if((mtu > 0) && (mtu <= ETH_MAX_TAGGED_CONTENT(device->flags))){
-			device->mtu = mtu;
-		}else{
-			 device->mtu = ETH_MAX_TAGGED_CONTENT(device->flags);
-		}
-		configuration = &names[0];
-		if(ERROR_OCCURRED(net_get_device_conf_req(eth_globals.net_phone, device->device_id, &configuration, count, &data))){
-			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-			free(device);
-			return ERROR_CODE;
-		}
-		if(configuration){
-			if(! str_lcmp(configuration[0].value, "DIX", configuration[0].length)){
-				device->flags |= ETH_DIX;
-			}else if(! str_lcmp(configuration[0].value, "8023_2_LSAP", configuration[0].length)){
-				device->flags |= ETH_8023_2_LSAP;
-			}else device->flags |= ETH_8023_2_SNAP;
-			if((configuration[1].value) && (configuration[1].value[0] == 'y')){
-				device->flags |= ETH_DUMMY;
-			}
-			net_free_settings(configuration, data);
-		}else{
+		}
+		fibril_rwlock_read_unlock(&eth_globals.protos_lock);
+		return EOK;
+	}
+	
+	// create a new device
+	device = (eth_device_ref) malloc(sizeof(eth_device_t));
+	if (!device)
+		return ENOMEM;
+
+	device->device_id = device_id;
+	device->service = service;
+	device->flags = 0;
+	if ((mtu > 0) && (mtu <= ETH_MAX_TAGGED_CONTENT(device->flags)))
+		device->mtu = mtu;
+	else
+		device->mtu = ETH_MAX_TAGGED_CONTENT(device->flags);
+
+	configuration = &names[0];
+	rc = net_get_device_conf_req(eth_globals.net_phone, device->device_id,
+	    &configuration, count, &data);
+	if (rc != EOK) {
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+		free(device);
+		return rc;
+	}
+	if (configuration) {
+		if (!str_lcmp(configuration[0].value, "DIX",
+		    configuration[0].length)) {
+			device->flags |= ETH_DIX;
+		} else if(!str_lcmp(configuration[0].value, "8023_2_LSAP",
+		    configuration[0].length)) {
+			device->flags |= ETH_8023_2_LSAP;
+		} else {
 			device->flags |= ETH_8023_2_SNAP;
 		}
-		// bind the device driver
-		device->phone = netif_bind_service(device->service, device->device_id, SERVICE_ETHERNET, eth_receiver);
-		if(device->phone < 0){
-			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-			free(device);
-			return device->phone;
-		}
-		// get hardware address
-		if(ERROR_OCCURRED(netif_get_addr_req(device->phone, device->device_id, &device->addr, &device->addr_data))){
-			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-			free(device);
-			return ERROR_CODE;
-		}
-		// add to the cache
-		index = eth_devices_add(&eth_globals.devices, device->device_id, device);
-		if(index < 0){
-			fibril_rwlock_write_unlock(&eth_globals.devices_lock);
-			free(device->addr);
-			free(device->addr_data);
-			free(device);
-			return index;
-		}
-		printf("%s: Device registered (id: %d, service: %d: mtu: %d, "
-		    "mac: %x:%x:%x:%x:%x:%x, flags: 0x%x)\n",
-		    NAME, device->device_id, device->service, device->mtu,
-		    device->addr_data[0], device->addr_data[1],
-		    device->addr_data[2], device->addr_data[3],
-		    device->addr_data[4], device->addr_data[5], device->flags);
-	}
+		
+		if (configuration[1].value &&
+		    (configuration[1].value[0] == 'y')) {
+			device->flags |= ETH_DUMMY;
+		}
+		net_free_settings(configuration, data);
+	} else {
+		device->flags |= ETH_8023_2_SNAP;
+	}
+	
+	// bind the device driver
+	device->phone = netif_bind_service(device->service, device->device_id,
+	    SERVICE_ETHERNET, eth_receiver);
+	if (device->phone < 0) {
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+		free(device);
+		return device->phone;
+	}
+	
+	// get hardware address
+	rc = netif_get_addr_req(device->phone, device->device_id, &device->addr,
+	    &device->addr_data);
+	if (rc != EOK) {
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+		free(device);
+		return rc;
+	}
+	
+	// add to the cache
+	index = eth_devices_add(&eth_globals.devices, device->device_id,
+	    device);
+	if (index < 0) {
+		fibril_rwlock_write_unlock(&eth_globals.devices_lock);
+		free(device->addr);
+		free(device->addr_data);
+		free(device);
+		return index;
+	}
+	
+	printf("%s: Device registered (id: %d, service: %d: mtu: %d, "
+	    "mac: %x:%x:%x:%x:%x:%x, flags: 0x%x)\n",
+	    NAME, device->device_id, device->service, device->mtu,
+	    device->addr_data[0], device->addr_data[1],
+	    device->addr_data[2], device->addr_data[3],
+	    device->addr_data[4], device->addr_data[5], device->flags);
+
 	fibril_rwlock_write_unlock(&eth_globals.devices_lock);
 	return EOK;
 }
 
-eth_proto_ref eth_process_packet(int flags, packet_t packet){
-	ERROR_DECLARE;
-
+/** Processes the received packet and chooses the target registered module.
+ *
+ * @param[in] flags	The device flags.
+ * @param[in] packet	The packet.
+ * @returns		The target registered module.
+ * @returns		NULL if the packet is not long enough.
+ * @returns		NULL if the packet is too long.
+ * @returns		NULL if the raw ethernet protocol is used.
+ * @returns		NULL if the dummy device FCS checksum is invalid.
+ * @returns		NULL if the packet address length is not big enough.
+ */
+static eth_proto_ref eth_process_packet(int flags, packet_t packet)
+{
 	eth_header_snap_ref header;
 	size_t length;
@@ -423,15 +437,20 @@
 	size_t suffix;
 	eth_fcs_ref fcs;
-	uint8_t * data;
+	uint8_t *data;
+	int rc;
 
 	length = packet_get_data_length(packet);
-	if(IS_DUMMY(flags)){
+	
+	if (IS_DUMMY(flags))
 		packet_trim(packet, sizeof(eth_preamble_t), 0);
-	}
-	if(length < sizeof(eth_header_t) + ETH_MIN_CONTENT + (IS_DUMMY(flags) ? ETH_SUFFIX : 0)) return NULL;
+	if (length < sizeof(eth_header_t) + ETH_MIN_CONTENT +
+	    (IS_DUMMY(flags) ? ETH_SUFFIX : 0))
+		return NULL;
+	
 	data = packet_get_data(packet);
 	header = (eth_header_snap_ref) data;
 	type = ntohs(header->header.ethertype);
-	if(type >= ETH_MIN_PROTO){
+	
+	if (type >= ETH_MIN_PROTO) {
 		// DIX Ethernet
 		prefix = sizeof(eth_header_t);
@@ -439,42 +458,56 @@
 		fcs = (eth_fcs_ref) data + length - sizeof(eth_fcs_t);
 		length -= sizeof(eth_fcs_t);
-	}else if(type <= ETH_MAX_CONTENT){
+	} else if(type <= ETH_MAX_CONTENT) {
 		// translate "LSAP" values
-		if((header->lsap.dsap == ETH_LSAP_GLSAP) && (header->lsap.ssap == ETH_LSAP_GLSAP)){
+		if ((header->lsap.dsap == ETH_LSAP_GLSAP) &&
+		    (header->lsap.ssap == ETH_LSAP_GLSAP)) {
 			// raw packet
 			// discard
 			return NULL;
-		}else if((header->lsap.dsap == ETH_LSAP_SNAP) && (header->lsap.ssap == ETH_LSAP_SNAP)){
+		} else if((header->lsap.dsap == ETH_LSAP_SNAP) &&
+		    (header->lsap.ssap == ETH_LSAP_SNAP)) {
 			// IEEE 802.3 + 802.2 + LSAP + SNAP
 			// organization code not supported
 			type = ntohs(header->snap.ethertype);
-			prefix = sizeof(eth_header_t) + sizeof(eth_header_lsap_t) + sizeof(eth_header_snap_t);
-		}else{
+			prefix = sizeof(eth_header_t) +
+			    sizeof(eth_header_lsap_t) +
+			    sizeof(eth_header_snap_t);
+		} else {
 			// IEEE 802.3 + 802.2 LSAP
 			type = lsap_map(header->lsap.dsap);
-			prefix = sizeof(eth_header_t) + sizeof(eth_header_lsap_t);
-		}
-		suffix = (type < ETH_MIN_CONTENT) ? ETH_MIN_CONTENT - type : 0u;
+			prefix = sizeof(eth_header_t) +
+			    sizeof(eth_header_lsap_t);
+		}
+		suffix = (type < ETH_MIN_CONTENT) ? ETH_MIN_CONTENT - type : 0U;
 		fcs = (eth_fcs_ref) data + prefix + type + suffix;
 		suffix += length - prefix - type;
 		length = prefix + type + suffix;
-	}else{
+	} else {
 		// invalid length/type, should not occurr
 		return NULL;
 	}
-	if(IS_DUMMY(flags)){
-		if((~ compute_crc32(~ 0u, data, length * 8)) != ntohl(*fcs)){
+	
+	if (IS_DUMMY(flags)) {
+		if (~compute_crc32(~0U, data, length * 8) != ntohl(*fcs))
 			return NULL;
-		}
 		suffix += sizeof(eth_fcs_t);
 	}
-	if(ERROR_OCCURRED(packet_set_addr(packet, header->header.source_address, header->header.destination_address, ETH_ADDR))
-		|| ERROR_OCCURRED(packet_trim(packet, prefix, suffix))){
+	
+	rc = packet_set_addr(packet, header->header.source_address,
+	    header->header.destination_address, ETH_ADDR);
+	if (rc != EOK)
 		return NULL;
-	}
+
+	rc = packet_trim(packet, prefix, suffix);
+	if (rc != EOK)
+		return NULL;
+	
 	return eth_protos_find(&eth_globals.protos, type);
 }
 
-int nil_received_msg_local(int nil_phone, device_id_t device_id, packet_t packet, services_t target){
+int
+nil_received_msg_local(int nil_phone, device_id_t device_id, packet_t packet,
+    services_t target)
+{
 	eth_proto_ref proto;
 	packet_t next;
@@ -484,5 +517,5 @@
 	fibril_rwlock_read_lock(&eth_globals.devices_lock);
 	device = eth_devices_find(&eth_globals.devices, device_id);
-	if(! device){
+	if (!device) {
 		fibril_rwlock_read_unlock(&eth_globals.devices_lock);
 		return ENOENT;
@@ -490,29 +523,47 @@
 	flags = device->flags;
 	fibril_rwlock_read_unlock(&eth_globals.devices_lock);
+	
 	fibril_rwlock_read_lock(&eth_globals.protos_lock);
-	do{
+	do {
 		next = pq_detach(packet);
 		proto = eth_process_packet(flags, packet);
-		if(proto){
-			il_received_msg(proto->phone, device_id, packet, proto->service);
-		}else{
+		if (proto) {
+			il_received_msg(proto->phone, device_id, packet,
+			    proto->service);
+		} else {
 			// drop invalid/unknown
-			pq_release_remote(eth_globals.net_phone, packet_get_id(packet));
+			pq_release_remote(eth_globals.net_phone,
+			    packet_get_id(packet));
 		}
 		packet = next;
-	}while(packet);
+	} while(packet);
 	fibril_rwlock_read_unlock(&eth_globals.protos_lock);
+	
 	return EOK;
 }
 
-int eth_packet_space_message(device_id_t device_id, size_t * addr_len, size_t * prefix, size_t * content, size_t * suffix){
+/** Returns the device packet dimensions for sending.
+ *
+ * @param[in] device_id	The device identifier.
+ * @param[out] addr_len	The minimum reserved address length.
+ * @param[out] prefix	The minimum reserved prefix size.
+ * @param[out] content	The maximum content size.
+ * @param[out] suffix	The minimum reserved suffix size.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if either one of the parameters is NULL.
+ * @returns		ENOENT if there is no such device.
+ */
+static int
+eth_packet_space_message(device_id_t device_id, size_t *addr_len,
+    size_t *prefix, size_t *content, size_t *suffix)
+{
 	eth_device_ref device;
 
-	if(!(addr_len && prefix && content && suffix)){
+	if (!addr_len || !prefix || !content || !suffix)
 		return EBADMEM;
-	}
+	
 	fibril_rwlock_read_lock(&eth_globals.devices_lock);
 	device = eth_devices_find(&eth_globals.devices, device_id);
-	if(! device){
+	if (!device) {
 		fibril_rwlock_read_unlock(&eth_globals.devices_lock);
 		return ENOENT;
@@ -520,4 +571,5 @@
 	*content = device->mtu;
 	fibril_rwlock_read_unlock(&eth_globals.devices_lock);
+	
 	*addr_len = ETH_ADDR;
 	*prefix = ETH_PREFIX;
@@ -526,16 +578,28 @@
 }
 
-int eth_addr_message(device_id_t device_id, eth_addr_type_t type, measured_string_ref * address){
+/** Returns the device hardware address.
+ *
+ * @param[in] device_id	The device identifier.
+ * @param[in] type	Type of the desired address.
+ * @param[out] address	The device hardware address.
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the address parameter is NULL.
+ * @returns		ENOENT if there no such device.
+ */
+static int
+eth_addr_message(device_id_t device_id, eth_addr_type_t type,
+    measured_string_ref *address)
+{
 	eth_device_ref device;
 
-	if(! address){
+	if (!address)
 		return EBADMEM;
-	}
-	if(type == ETH_BROADCAST_ADDR){
+
+	if (type == ETH_BROADCAST_ADDR) {
 		*address = eth_globals.broadcast_addr;
-	}else{
+	} else {
 		fibril_rwlock_read_lock(&eth_globals.devices_lock);
 		device = eth_devices_find(&eth_globals.devices, device_id);
-		if(! device){
+		if (!device) {
 			fibril_rwlock_read_unlock(&eth_globals.devices_lock);
 			return ENOENT;
@@ -544,8 +608,20 @@
 		fibril_rwlock_read_unlock(&eth_globals.devices_lock);
 	}
+	
 	return (*address) ? EOK : ENOENT;
 }
 
-int eth_register_message(services_t service, int phone){
+/** Registers receiving module service.
+ *
+ * Passes received packets for this service.
+ *
+ * @param[in] service	The module service.
+ * @param[in] phone	The service phone.
+ * @returns		EOK on success.
+ * @returns		ENOENT if the service is not known.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+static int eth_register_message(services_t service, int phone)
+{
 	eth_proto_ref proto;
 	int protocol;
@@ -553,16 +629,16 @@
 
 	protocol = protocol_map(SERVICE_ETHERNET, service);
-	if(! protocol){
+	if (!protocol)
 		return ENOENT;
-	}
+
 	fibril_rwlock_write_lock(&eth_globals.protos_lock);
 	proto = eth_protos_find(&eth_globals.protos, protocol);
-	if(proto){
+	if (proto) {
 		proto->phone = phone;
 		fibril_rwlock_write_unlock(&eth_globals.protos_lock);
 		return EOK;
-	}else{
+	} else {
 		proto = (eth_proto_ref) malloc(sizeof(eth_proto_t));
-		if(! proto){
+		if (!proto) {
 			fibril_rwlock_write_unlock(&eth_globals.protos_lock);
 			return ENOMEM;
@@ -572,5 +648,5 @@
 		proto->phone = phone;
 		index = eth_protos_add(&eth_globals.protos, protocol, proto);
-		if(index < 0){
+		if (index < 0) {
 			fibril_rwlock_write_unlock(&eth_globals.protos_lock);
 			free(proto);
@@ -579,6 +655,6 @@
 	}
 	
-	printf("%s: Protocol registered (protocol: %d, service: %d, phone: %d)\n",
-	    NAME, proto->protocol, proto->service, proto->phone);
+	printf("%s: Protocol registered (protocol: %d, service: %d, phone: "
+	    "%d)\n", NAME, proto->protocol, proto->service, proto->phone);
 	
 	fibril_rwlock_write_unlock(&eth_globals.protos_lock);
